/* eitrove - iTrove file encoder
 * by Chris Young <chris@unsatisfactorysoftware.co.uk> 2013
 * For more information see http://www.terrestrialtv.co.uk/blog/
 *
 * This source code is provided for educational purposes only,
 * and is not intended to be useful, stable, working or complete.
 * All use is at your own risk.
*/

#include <stdio.h>

void byteswap(char **value)
{
	char swapval[4];
	
	swapval[0] = *value[3];
	swapval[1] = *value[2];
	swapval[2] = *value[1];
	swapval[3] = *value[0];
	
	*value[0] = swapval[0];
	*value[1] = swapval[1];
	*value[2] = swapval[2];
	*value[3] = swapval[3];
}

int main(int argc, char **argv)
{
	if(argc < 3) return 10;

	const char *in_file = argv[1];
	const char *out_file = argv[2];
	FILE *infh, *outfh;
	long size, bytes, readbytes, crc;
	int fileid, dirid;
	char trove_size[4];
	char buffer[1024];
	
	infh = fopen(in_file, "r");
	
	fseek(infh, 0, SEEK_END);
	size = ftell(infh);
	fseek(infh, 0, SEEK_SET);
	
	outfh = fopen(out_file, "w");

	fputc(0x10, outfh);
	fputc(0x00, outfh);
	fputc(0x00, outfh);
	fputc(0x00, outfh);

	fputc(0x00, outfh);
	fputc(0x00, outfh);
	fputc(0x01, outfh);
	fputc(0x00, outfh);

	/* 00dfff04 */
	fputc(0x00, outfh);
	
	fileid = atoi(argv[3]);
	printf("File ID: %lx\n", fileid);
	fwrite(&fileid, 1, 2, outfh);

	fputc(0x01, outfh);

	fputc(0x00, outfh);
	fputc(0x00, outfh);
	fputc(0x00, outfh);
	fputc(0x05, outfh);

	printf("Input file size = %ld\n", size);
	
	size += 2;
	
	printf("Header file size = %lx\n", size);

	fwrite(&size, 1, 4, outfh);

	fputc(0x00, outfh);
	fputc(0x00, outfh);	

	bytes = 2;
	
	while (bytes < size) {
		if(bytes >= 1024) readbytes = 1024;
		else readbytes = size - bytes;
		
		fread(&buffer, 1, readbytes, infh);
		fwrite(&buffer, 1, readbytes, outfh);
		bytes += readbytes;
	}
	fflush(outfh);
	fclose(outfh);
	fclose(infh);
	
	/* add CRC32 to end of output file */
	crc = crc32_file(out_file);
	
	outfh = fopen(out_file, "a+");
	fwrite(&crc, 1, 4, outfh);
	fclose(outfh);
}

