/* xitrove - iTrove file extractor.
 * by Chris Young <chris@unsatisfactorysoftware.co.uk> 2013
 * For more information see http://www.terrestrialtv.co.uk/blog/
 *
 * This source code is provided for educational purposes only,
 * and is not intended to be useful, stable, working or complete.
 * All use is at your own risk.
*/

#include <stdio.h>

int main(int argc, char **argv)
{
	long read_bytes = 0, size;
	long buffer[1024];
//	char buffer[1024];

	if(argc < 3) {
		printf("invalid args\n");
		return 5;
	}

	FILE *fh = fopen(argv[1], "r");
	FILE *outfh = fopen(argv[2], "w");
	fread(&buffer, 1, 5 * 4, fh);
/*
	long length = buffer[16] |
			(buffer[17] << 8) |
			(buffer[18] << 16) |
			(buffer[19] << 24);
*/

	long length = buffer[4]; /* TODO: endian awareness */

	printf("Length = %ld\n", length);

	size = fread(&buffer, 1, 2, fh); // discard extra two bytes

	while(read_bytes < length) {
		if((length - read_bytes) >= 1024) {
			size = 1024;
		} else {
			size = length - read_bytes;
		}
		size = fread(&buffer, 1, size, fh);
		if(size == -1) return 10;

		read_bytes += size;
//printf("%ld %ld %ld\n", size, read_bytes, length);
		fwrite(&buffer, 1, size, outfh);
	}

	fclose(fh);
	fclose(outfh);
}

